/*
 * SimpleDraw.c
 *
 * Example program illustrating a simple use
 * of OpenGL to draw straight lines in 2D, and
 * to draw overlapping triangles in 3D.
 *
 * Author: Samuel R. Buss
 *
 * Software accompanying the book
 *		3D Computer Graphics: A Mathematical Introduction with OpenGL,
 *		by S. Buss, Cambridge University Press, 2003.
 *
 * Software is "as-is" and carries no warranty.  It may be used without
 *   restriction, but if you modify it, please change the filenames to
 *   prevent confusion between different versions.
 * Bug reports: Sam Buss, sbuss@ucsd.edu.
 * Web page: http://math.ucsd.edu/~sbuss/MathCG
 *
 * Version 1.1.  Updated September 28, 2003.
 *   1.1. 9/28/30: Added glEnable(GL_DEPTH_TEST).  Thanks to Rob Wilkens.
 *   1.0. Original version released Spring 2003.
 *
 */

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "glut.h"	// OpenGL Graphics Utility Library
#include "SimpleDraw.h"
#include "texture.h"


//my Declarations

double d_count = -40;
double x_2 = 1;
float time = 0;//(NEW) variable to record the how much time has passed
double building;
//Health Tank #1 Declarations
double tank1xloc;
double tank1yloc;
//Health Tank #2 Declarations
double tank2xloc;
double tank2yloc;
//Health Tank #3 Declarations
double tank3xloc;
double tank3yloc;
//Background movment (speed) declarations
double buildingxloc;
double buildingyloc;
//Projectile declarations
double bulletloc;
double projectileloc;
double fkey = 0;
double Fkey = 0;
//Enemy declarations
double enemyxloc = 100;
double findenemy =0;
double enemyfound ();
double enemymove;
double netenemyloc;
//end game
double endgame ();
double gameoverv;

// These variables set the dimensions of the rectanglar region we wish to view.
 double Xmin = -50.0, Xmax = 50.0;
 double Ymin = -10.0, Ymax = 100.0;

// glutKeyboardFunc is called below to set this function to handle
//		all "normal" ascii key presses.
// Only space bar and escape key have an effect.


 void myKeyboardFunc( unsigned char key, int x, int y )
{
	switch ( key ) {

	case ' ':									// Space bar
		// Increment the current mode, and tell operating system screen needs redrawing
				d_count = d_count + 1;
				if (d_count != +100)

				{
				//	glTranslatef(.5,0,0);
				buildingxloc = buildingxloc -0.75;
				}

				if (d_count == +100)
				{
				//	glTranslatef(-100,0,0);
				buildingxloc = buildingyloc + 100;
				d_count = -110;
				}
				glutPostRedisplay();

				break;

	case 'F':									// 'F' key

				{
				projectileloc =0;
					Fkey=1;
				break;
				}


	case 27:									// "27" is theEscape key
				exit(1);


	case 'f':									// 'f' key

				{
				bulletloc = 0;
				fkey=1;
				break;
				}


				

	



				}

}




void drawScene(void)
{
	// Clear the rendering window
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// Set drawing color to white
	glColor3f( 1.0, 0.9, 0.9 );		


//glLoadIdentity();


// binds the texture to any geometry about to be rendered
//g_Texture = LoadTexture("texture.bmp");
//glBindTexture(GL_TEXTURE_2D,g_Texture);


		//Buildings
	  glBegin( GL_POLYGON );
		glColor3f ( 0.0, 0,  3.0 );
		glTexCoord2f(0,0);
		glVertex3f( -40+buildingxloc, 0,  3.0 );
glTexCoord2f(0,1);
		glVertex3f( -40+buildingxloc, 30, 3.0 );
glTexCoord2f(1,1);
		glVertex3f( -25+buildingxloc, 30, 3.0 );
glTexCoord2f(1,0);
		glVertex3f( -25+buildingxloc, 0,  3.0 );
		glVertex3f( -40+buildingxloc, 0,  3.0 );
//		glEnd();

	  glBegin( GL_POLYGON );
		glColor3f ( 0.0, 0,  3.0 );
		glVertex3f( -60+buildingxloc, 0,  3.0 );
		glVertex3f( -60+buildingxloc, 40, 3.0 );
		glVertex3f( -45+buildingxloc, 40, 3.0 );
		glVertex3f( -45+buildingxloc, 0,  3.0 );
		glVertex3f( -60+buildingxloc, 0,  3.0 );
		
		
	  glBegin(GL_LINE_STRIP);
		glVertex2f( -40+buildingxloc, 0  );
		glVertex2f( -40+buildingxloc, 30 );
		glVertex2f( -25+buildingxloc, 30 );
		glVertex2f( -25+buildingxloc, 0  );
		glEnd();
	  glBegin(GL_LINE_STRIP);
		glVertex2f( -60+buildingxloc, 0 );
		glVertex2f( -60+buildingxloc, 40 );
		glVertex2f( -45+buildingxloc,40);
		glVertex2f( -45+buildingxloc, 0 );
		glEnd();
	  glBegin(GL_LINE_STRIP);
		glVertex2f( -40+buildingxloc, 0 );
		glVertex2f( -40+buildingxloc, 30 );
		glVertex2f( -25+buildingxloc,30);
		glVertex2f( -25+buildingxloc, 0 );
		glEnd();
		  glBegin(GL_LINE_STRIP);
		glVertex2f( -30+buildingxloc, 30 );
		glVertex2f( -30+buildingxloc, 50 );
		glVertex2f( -10+buildingxloc, 50);
		glVertex2f( -10+buildingxloc, 0 );
		glEnd();
		  glBegin(GL_LINE_STRIP);
		glVertex2f( 0+buildingxloc, 0 );
		glVertex2f( 0+buildingxloc, 25 );
		glVertex2f( 20+buildingxloc ,25);
		glVertex2f( 20+buildingxloc, 0 );
		glEnd();
		  glBegin(GL_LINE_STRIP);
		glVertex2f( 18+buildingxloc, 25 );
		glVertex2f( 18+buildingxloc, 45 );
		glVertex2f( 32+buildingxloc ,45);
		glVertex2f( 32+buildingxloc, 0 );
		glEnd();
		glBegin(GL_LINE_STRIP);
		glVertex2f( -200+buildingxloc, 0 );
		glVertex2f(  200+buildingxloc, 0 );
		glEnd();



d_count = d_count + 1;
if (d_count != +100)

{
//	glTranslatef(.5,0,0);
buildingxloc = buildingxloc -0.25;
}

if (d_count == +100)
{
//	glTranslatef(-100,0,0);
buildingxloc = buildingyloc + 100;
	d_count = -110;
}

	
			//Tank Body Poly
			glBegin( GL_POLYGON );
			glColor3f ( 3, 3.0, 3.0 );
			glVertex3f( -5.0, 0.0, 2.0 );
			glVertex3f( 5.0, 0.0, 0.0 );
			glVertex3f( 8.0, 3.0, 2.0 );
			glVertex3f( -8.0, 3.0, 2.0 );
			glVertex3f( -5.0, 0.0, 2.0 );
			//	glEnd();
			//Tank Body Poly
			//	glBegin( GL_POLYGON );
			glColor3f ( 3, 3.0, 3.0 );
			glVertex3f( -6.0, 0.0, 2.0 );
			glVertex3f( 8.0, 2.5, 0.0 );
			glVertex3f( -8.0, 2.5, 2.0 );
			glVertex3f( -6.0, 0.0, 2.0 );
			glEnd();
			//Tank Top Poly
			glBegin( GL_POLYGON );
			glColor3f ( 3, 3.0, 3.0 );
			glVertex3f( -8.0, 2.5, 2.0 );
			glVertex3f( -7.0, 3.2, 0.0 );
			glVertex3f( 7.0, 3.2, 2.0 );
			glVertex3f( 8.0, 2.5, 2.0 );
			glEnd();

		
	//Tank Body Line
		glBegin(GL_LINE_STRIP);
		glVertex2f( -6, 0 );
		glVertex2f( 5, 0 );
		glVertex2f( 8, 2.5 );
		glVertex2f( -8, 2.5);
		glVertex2f( -6, 0 );
	//Tank Top ine
		glBegin(GL_LINE_STRIP);
		glVertex2f( -8, 2.5 );
		glVertex2f( -7, 3.2 );
		glVertex2f( 7, 3.2 );
		glVertex2f( 8, 2.5 );
	//Tank Turret Line
		glBegin(GL_LINE_STRIP);
		glVertex2f( 3, 3 );
		glVertex2f( 1, 5 );
		glVertex2f( -3, 3 );
	//Barrel Line
	  glBegin(GL_LINE_STRIP);
		glVertex2f( 1.2, 4.5 );
		glVertex2f( 10, 4.5 );
		glVertex2f( 9.6,4.1);
		glVertex2f( 1.4, 4.1 );
		glEnd();
	













 //firing commands
	if (fkey == 1) //Bullets
	{
bulletloc = bulletloc + 3;
	glBegin(GL_LINE_STRIP);
		glVertex2f( 8.2+bulletloc, 3.05 );
		glVertex2f( 8+bulletloc, 3.05 );
		glVertex2f( 8+bulletloc, 3.1);
		glVertex2f( 8.2+bulletloc, 3.1 );
		glVertex2f( 8.2+bulletloc, 3.05 );
		glEnd();
//	if (bulletloc > Xmax)
//	{
//		bulletloc = 0;
//	}
	}
if (Fkey == 1) //Projectile
projectileloc=projectileloc+2;
	{	
	  glBegin(GL_LINE_STRIP);
		glVertex2f( 8.4+projectileloc, 4.3 );
		glVertex2f( 8+projectileloc, 4.3 );
		glVertex2f( 8+projectileloc, 4.1);
		glVertex2f( 8.4+projectileloc, 4.1 );
		glVertex2f( 8.4+projectileloc, 4.3 );
		glEnd();
	}



//Health Bar

		//Frame
			//Left
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( -5+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  -5.2+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  -5.2+tank1xloc, 0+tank1yloc, -0.1 );
			glVertex3f( -5+tank1xloc, 0+tank1yloc, -0.1);
							glEnd();

			//Inside
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( -5+tank1xloc, 4+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 4+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 4.2+tank1yloc, -0.1 );
			glVertex3f( -5+tank1xloc, 4.2+tank1yloc, -0.1);
			glEnd();


			//Top
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( -5+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 5.2+tank1yloc, -0.1 );
			glVertex3f( -5+tank1xloc, 5.2+tank1yloc, -0.1);
							glEnd();	
			//Bottom
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( -5+tank1xloc, -0.2+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, -0.2+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 0+tank1yloc, -0.1 );
			glVertex3f( -5+tank1xloc, 0+tank1yloc, -0.1);
							glEnd();
			//Right
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( 25+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25.2+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25.2+tank1xloc, 0+tank1yloc, -0.1 );
			glVertex3f( 25+tank1xloc, 0+tank1yloc, -0.1);
							glEnd();


/*
			glBegin( GL_POLYGON );
			glColor3f ( 0.9, 0.9, 0.9 );
			glVertex3f( -5+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 5+tank1yloc, -0.1 );
			glVertex3f(  25+tank1xloc, 0+tank1yloc, -0.1 );
			glVertex3f( -5+tank1xloc, 0+tank1yloc, -0.1);
							glEnd();							
							
*/							
							
							
							
							
							
							
							
tank1xloc=-65;
tank1yloc= 90;
tank2xloc= tank1xloc +10;
tank3xloc= tank2xloc +10;	
	//Game Life Tank One
			//Tank Body Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.002, 0.4, 0.002 );
			glVertex3f( -2.5+tank1xloc, 0.0+tank1yloc, 0.0 );
			glVertex3f( 2.5+tank1xloc, 0.0+tank1yloc, 0.0 );
			glVertex3f( 4.0+tank1xloc, 1.5+tank1yloc, 0.0 );
			glVertex3f( 3.5+tank1xloc, 1.25+tank1yloc, 0.0);
			glVertex3f( 3.25+tank1xloc, 1.5+tank1yloc, 0.0);
			glVertex3f( -4.0+tank1xloc, 1.5+tank1yloc, 0.0 );
			glVertex3f( -2.5+tank1xloc, 0.0+tank1yloc, 0.0 );
			//	glEnd();
			//Tank Body Poly
			//	glBegin( GL_POLYGON );
			glColor3f ( 0.000, 0.4, 0.000 );
			glVertex3f( -3.0+tank1xloc, 0.0+tank1yloc, 0.0 );
			glVertex3f( 4.0+tank1xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -4.0+tank1xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.0+tank1xloc, 0.0+tank1yloc, 0.0 );
			glEnd();
			//Tank Top Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.1500, 0.15, 0.1500 );
			glVertex3f( -4.0+tank1xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.5+tank1xloc, 1.6+tank1yloc, 0.0 );
			glVertex3f( 3.5+tank1xloc, 1.6+tank1yloc, 0.0 );
			glVertex3f( 4.0+tank1xloc, 1.6+tank1yloc, 0.0 );
			glEnd();
			//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f ( .002, .4, 0.002 );
			glVertex3f( .5+tank1xloc, 2.5+tank1yloc, 0.0 );
			glColor3f ( .001, .3, .001 );
			glVertex3f( 1.5+tank1xloc, 1.5+tank1yloc, 0.0 );
			glVertex3f( -1.5+tank1xloc, 1.5+tank1yloc, 0.0 );
		//	glVertex3f( 8.0, 2.5, 0.0 );
			glEnd();
		
						//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f ( .1, .1, 0.1 );
			glVertex3f( 0.6+tank1xloc, 2.2+tank1yloc, 0.0 );
			glVertex3f( 4.5+tank1xloc, 2.2+tank1yloc, 0.0 );			
			glColor3f ( .2, .2, .2 );
			glVertex3f( 4.5+tank1xloc, 1.9+tank1yloc, 0.0 );
			glVertex3f( 0.7+tank1xloc, 1.9+tank1yloc, 0.0 );
			glEnd();
		//End Tank Health 1
	//Game Life Tank Two
			//Tank Body Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.002, 0.4, 0.002 );
			glVertex3f( -2.5 +tank2xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  2.5 +tank2xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  4.0 +tank2xloc, 1.5 +tank1yloc, 0.0 );
			glVertex3f(  3.5 +tank2xloc, 1.25+tank1yloc, 0.0);
			glVertex3f(  3.25+tank2xloc, 1.5 +tank1yloc, 0.0);
			glVertex3f( -4.0 +tank2xloc, 1.5 +tank1yloc, 0.0 );
			glVertex3f( -2.5 +tank2xloc, 0.0 +tank1yloc, 0.0 );
			//	glEnd();
			//Tank Body Poly
			//	glBegin( GL_POLYGON );
			glColor3f ( 0.000, 0.4, 0.000 );
			glVertex3f( -3.0+tank2xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  4.0+tank2xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -4.0+tank2xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.0+tank2xloc, 0   +tank1yloc, 0.0 );
			glEnd();
			//Tank Top Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.1500, 0.15, 0.1500 );
			glVertex3f( -4.0+tank2xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.5+tank2xloc, 1.6 +tank1yloc, 0.0 );
			glVertex3f(  3.5+tank2xloc, 1.6 +tank1yloc, 0.0 );
			glVertex3f(  4.0+tank2xloc, 1.6 +tank1yloc, 0.0 );
			glEnd();
			//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f (   .002, .4, 0.002 );
			glVertex3f(   .5+tank2xloc, 2.5+tank1yloc, 0.0 );
			glColor3f (   .001, .3, .001 );
			glVertex3f(  1.5+tank2xloc, 1.5+tank1yloc, 0.0 );
			glVertex3f( -1.5+tank2xloc, 1.5+tank1yloc, 0.0 );
		//	glVertex3f( 8.0, 2.5, 0.0 );
			glEnd();
		
						//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f ( .1, .1, 0.1 );
			glVertex3f( 0.6+tank2xloc, 2.2+tank1yloc, 0.0 );
			glVertex3f( 4.5+tank2xloc, 2.2+tank1yloc, 0.0 );			
			glColor3f ( .2, .2, .2 );
			glVertex3f( 4.5+tank2xloc, 1.9+tank1yloc, 0.0 );
			glVertex3f( 0.7+tank2xloc, 1.9+tank1yloc, 0.0 );
			glEnd();
		//End Tank Two
	//Game Life Tank Three
			//Tank Body Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.002, 0.4, 0.002 );
			glVertex3f( -2.5 +tank3xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  2.5 +tank3xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  4.0 +tank3xloc, 1.5 +tank1yloc, 0.0 );
			glVertex3f(  3.5 +tank3xloc, 1.25+tank1yloc, 0.0);
			glVertex3f(  3.25+tank3xloc, 1.5 +tank1yloc, 0.0);
			glVertex3f( -4.0 +tank3xloc, 1.5 +tank1yloc, 0.0 );
			glVertex3f( -2.5 +tank3xloc, 0.0 +tank1yloc, 0.0 );
			//	glEnd();
			//Tank Body Poly
			//	glBegin( GL_POLYGON );
			glColor3f ( 0.000, 0.4, 0.000 );
			glVertex3f( -3.0+tank3xloc, 0   +tank1yloc, 0.0 );
			glVertex3f(  4.0+tank3xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -4.0+tank3xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.0+tank3xloc, 0   +tank1yloc, 0.0 );
			glEnd();
			//Tank Top Poly
			glBegin( GL_POLYGON );
			glColor3f ( 0.1500, 0.15, 0.1500 );
			glVertex3f( -4.0+tank3xloc, 1.25+tank1yloc, 0.0 );
			glVertex3f( -3.5+tank3xloc, 1.6 +tank1yloc, 0.0 );
			glVertex3f(  3.5+tank3xloc, 1.6 +tank1yloc, 0.0 );
			glVertex3f(  4.0+tank3xloc, 1.6 +tank1yloc, 0.0 );
			glEnd();
			//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f (   .002, .4, 0.002 );
			glVertex3f(   .5+tank3xloc, 2.5+tank1yloc, 0.0 );
			glColor3f (   .001, .3, .001 );
			glVertex3f(  1.5+tank3xloc, 1.5+tank1yloc, 0.0 );
			glVertex3f( -1.5+tank3xloc, 1.5+tank1yloc, 0.0 );
		//	glVertex3f( 8.0, 2.5, 0.0 );
			glEnd();
		
						//Tank Turret Line
			glBegin( GL_POLYGON );
			glColor3f ( .1, .1, 0.1 );
			glVertex3f( 0.6+tank3xloc, 2.2+tank1yloc, 0.0 );
			glVertex3f( 4.5+tank3xloc, 2.2+tank1yloc, 0.0 );			
			glColor3f ( .2, .2, .2 );
			glVertex3f( 4.5+tank3xloc, 1.9+tank1yloc, 0.0 );
			glVertex3f( 0.7+tank3xloc, 1.9+tank1yloc, 0.0 );
			glEnd();
		//End Tank Three





glutSwapBuffers();
  // Flush the pipeline.  (Not usually necessary.)
	glFlush();

}

// Initialize OpenGL's rendering modes








// Initialize OpenGL's rendering modes
void initRendering()
{

	glEnable ( GL_DEPTH_TEST );

	// Uncomment out the first block of code below, and then the second block,
	//		to see how they affect line and point drawing.

	// The following commands should cause points and line to be drawn larger
	//	than a single pixel width.
	glPointSize(3);
	glLineWidth(2);



	// The following commands should induce OpenGL to create round points and 
	//	antialias points and lines.  (This is implementation dependent unfortunately).
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);	// Make round points, not square points
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);		// Antialias the lines
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


}

// Called when the window is resized
//		w, h - width and height of the window in pixels.


void idle()
{
  //  time += 0.1;//(NEW) increase the time variable

   // if(time > 200)
       // time = 0;//(NEW) reset the time variable
		glutPostRedisplay();
}








void resizeWindow(int w, int h)
{
	double scale, center;
	double windowXmin, windowXmax, windowYmin, windowYmax;

	// Define the portion of the window used for OpenGL rendering.
	glViewport( 0, 0, w, h );	// View port uses whole window

	// Set up the projection view matrix: orthographic projection
	// Determine the min and max values for x and y that should appear in the window.
	// The complication is that the aspect ratio of the window may not match the
	//		aspect ratio of the scene we want to view.
	w = (w==0) ? 1 : w;
	h = (h==0) ? 1 : h;
	if ( (Xmax-Xmin)/w < (Ymax-Ymin)/h ) {
		scale = ((Ymax-Ymin)/h)/((Xmax-Xmin)/w);
		center = (Xmax+Xmin)/2;
		windowXmin = center - (center-Xmin)*scale;
		windowXmax = center + (Xmax-center)*scale;
		windowYmin = Ymin;
		windowYmax = Ymax;
	}
	else {
		scale = ((Xmax-Xmin)/w)/((Ymax-Ymin)/h);
		center = (Ymax+Ymin)/2;
		windowYmin = center - (center-Ymin)*scale;
		windowYmax = center + (Ymax-center)*scale;
		windowXmin = Xmin;
		windowXmax = Xmax;
	}
	
	// Now that we know the max & min values for x & y that should be visible in the window,
	//		we set up the orthographic projection.
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho( windowXmin, windowXmax, windowYmin, windowYmax, -1, 1 );

}


// Main routine
// Set up OpenGL, define the callbacks and start the main loop
int main( int argc, char** argv )
{
	glutInit(&argc,argv);
	// The image is not animated so single buffering is OK. 
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH );

	// Window position (from top corner), and size (width and hieght)

	glutInitWindowPosition( 200, 50 );
	glutInitWindowSize( 800, 600 );
	glutCreateWindow( "Scorch: A Problem of Epic Perportions" );

	// Initialize OpenGL as we like it..
	initRendering();

	// Set up callback functions for key presses
	glutKeyboardFunc( myKeyboardFunc );			// Handles "normal" ascii symbols
	// glutSpecialFunc( mySpecialKeyFunc );		// Handles "special" keyboard keys

	// Set up the callback function for resizing windows
	glutReshapeFunc( resizeWindow );

	// Call this for background processing
	// glutIdleFunc( myIdleFunction );

	// call this whenever window needs redrawing

	glutDisplayFunc( drawScene );
	fprintf(stdout, "Press space bar to toggle images; escape button to quit.\n");
	glutIdleFunc(idle);//(NEW) calls our idle function
	// Start the main loop.  glutMainLoop never returns.

	glutMainLoop(  );

	return(0);	// This line is never reached.
}
\